#include "prehtml.h"

FILE *sortie=NULL; /* stream dans lequel on crit */
int affiche=1; /* vrai si on doit afficher ce qu'on lit*/
int chut=0; /* vrai si on a cache un morceau */
const char *fin_read="pKJFDQSKFofIUEAZRJNWXC1245FDS";

void print(const char *format, ...){ /* crit dans le fichier cible */
	va_list ap;
	va_start(ap,format);
	if (debug && affiche && (!chut)) vfprintf(stdout,format,ap);
	if (affiche && (!chut)){
		if (sortie) vfprintf(sortie,format,ap);
		else erreur("print(): sortie==NULL");
	}
}
void put(char c){ /* idem, mais imite putc() au lieu de fprintf */
	if (debug && affiche && (!chut)) putc(c,stdout);
	if (affiche && (!chut)){
		if (sortie) putc(c,sortie);
		else erreur("put(): sortie==NULL");
	}
}
int vraifaux(const char *commande, const char *condition){ /* utilis par IF et WHILE */
	int i;
	string ligne;
	ligne = "if "+string(condition)+" >/dev/null; then echo VRAI; else echo FAUX; fi";
	envoieshell(ligne);
	recoitshell(ligne,0);
	if (!ligne.compare("VRAI")) i=1;
	else if (!ligne.compare("FAUX")) i=0;
	else {
		erreur("La condition <%s %s> ne donne ni vrai ni faux, mais:\n"
		       "%s\n",commande,condition,ligne.c_str());
	}
	if (recoitshell(ligne,0)){
		erreur("La condition <%s %s> donne des lignes en trop aprs VRAI ou FAUX:\n"
		       "%s\n",commande,chaine.c_str());
	}
	return i;
}

void traitefonction(void){
	string ligne;
	string lignetotale;
	string result;
	int i;
	infofor *cefor;
	infowhile *cewhile;
	infoinclude *ceinc;
	/************ FONCTIONS IMMDIATES ******************/
	/* <SHELL instruction  excuter par sh sans regarder la rponse> */
	if (!fonction.compare("shell")) 
		execshell(chaine); /* c'est simple */
	/* <ECHO argument  sortir comme la commande echo> */
	else if (!fonction.compare("echo")){ /* moins simple, mais a va */
		ligne="echo "+chaine;
		envoieshell(ligne);
		while(recoitshell(ligne,0)) {
			lignetotale += ligne;
		}
		result=recodeHTML(lignetotale);
		lignetotale.clear();
		print("%s",result.c_str());
		result.clear();
	}
	/* <ECHOnoESC>: comme <ECHO> mais ne remet pas les chappements HTML */
	else if (!fonction.compare("echonoesc")){ /* moins simple, mais a va */
		ligne="echo "+chaine;
		envoieshell(ligne);
		while(recoitshell(ligne,0))
			print("%s",ligne.c_str());
	}
	/* <SHELLECHO commande shell>, comme shell mais affiche le rsultat */
	else if (!fonction.compare("shellecho")){
		envoieshell(chaine);
		i=0;
		while(recoitshell(ligne,0)) {
			// if (i) put('\n'); /* sauts de ligne si plus d'une ligne */
			i=1;
			lignetotale=ligne;
			result=recodeHTML(lignetotale);
			print("%s",result.c_str());
			lignetotale.clear();
			result.clear();
		}
	}
	/* <SHELLECHOnoESC>: comme <SHELLECHO> mais ne remet pas les chappements HTML */
	else if (!fonction.compare("shellechonoesc")){
		envoieshell(chaine);
		i=0;
		while(recoitshell(ligne,0)){
			// if (i) put('\n'); /* sauts de ligne si plus d'une ligne */
			i=1;
			print("%s",ligne.c_str());
		}
	}
	/* <CHUT> ..... </CHUT>  cache une partie (pratique avec Netscape) */
	else if (!fonction.compare("chut")){
		chut++;
	}
	else if (!fonction.compare("/chut")){
		if (chut) chut--;
		else warning("</chut> trouv alors qu'on n'est pas dans <CHUT>");
	}
	/* <ERROR texte crit comme pour ECHO>: stoppe prehtml avec une erreur */
	else if (!fonction.compare("error")){
		ligne = "echo "+chaine;
		envoieshell(ligne);
		lignetotale.clear();
		while(recoitshell(ligne,0)) {
			lignetotale += ligne;
		}
		erreur("%s",lignetotale.c_str());
		lignetotale.clear();
	}
	/* <WARNING texte crit comme pour ECHO>: affiche un avertissement */
	else if (!fonction.compare("warning")){
		// bug retir le 24/05/2003: pourquoi diminuer le niveau de "chut"???
		//    if (chut) chut--;
		ligne="echo "+chaine;
		envoieshell(ligne);
		lignetotale.clear();
		while(recoitshell(ligne,0)) {
			lignetotale += ligne;
		}
		warning("%s",lignetotale.c_str());
		lignetotale.clear();
	}
	/* <TAG texte crit comme pour ECHO>: produit un TAG HTML */
	else if (!fonction.compare("tag")){
		ligne="echo "+chaine;
		envoieshell(ligne);
		while(recoitshell(ligne,1)) { // ici on supprime les fins de ligne:  chaque fois a donne un <TAG>
			lignetotale=ligne;
			result=recodeHTML(lignetotale);
			lignetotale.clear();
			print("<%s>",result.c_str());
			result.clear();
		}
	}
	/************** FONCTIONS IMBRIQUES *****************/
	/* <IF condition de if_shell, sans ";"> ... [ <ELSE> ... ] <FI>  */
	else if (!fonction.compare("if")){
		i=vraifaux("if",chaine.c_str());
		ouvre_imbrique();
		imbriqueactu->type=imbrique::IF;
		imbriqueactu->info.pourif.estvrai=i;
		if (!i) while (!i){ /* la condition est fausse */
			int ret = attend("else");
			if (ret == 0){ /* on a trouv <fi> avant de trouver <else> */
				referme_imbrique();
			} else if (ret == 2){ // on a trouv <elif>, if faut donc tester la condition, on reste dans l'imbrication
				i=vraifaux("elif",chaine.c_str());
				// imbriqueactu->type=imbrique::IF; // c'est dj le cas
				imbriqueactu->info.pourif.estvrai=i;
				continue; // reprendre comme aprs le <if>
			}
			/* sinon, c'est qu'on a trouv <else>, donc on excute */
			break; // ne pas cycler si on n'est pas dans le <elif>
		}
		/* sinon, c'est que la condition est vraie, donc on excute */
	}
	else if (!fonction.compare("else")){
		if (imbriqueactu->type != imbrique::IF || !imbriqueactu->info.pourif.estvrai){
			/* on a <else> et on n'tait pas dans <if>, ou on est dj ds <else>*/
			erreur("<else> inattendu");
		}
		attend("fi"); /* si le <else> est correct, on le saute jusqu' <fi> */
		referme_imbrique();
	}
	else if (!fonction.compare("elif")){
		if (imbriqueactu->type != imbrique::IF || !imbriqueactu->info.pourif.estvrai){
			/* on a <else> et on n'tait pas dans <if>, ou on est dj ds <else>*/
			erreur("<elif> inattendu");
		}
		/* si le <elif> est correct, on saute les <elif> (n) <else> (optionnel) jusqu'au <fi> */
		while(1){
			int ret = attend("else"); // 1=else, 0=fi, 2=elif
			if (ret==0)
				break; // aprs <fi>, c'est bon
			if (ret==1){
				attend("fi"); // aprs <else>, on attend <fi>
				break; // puis rien d'autre
			}
			// sinon c'tait <elif>, on continue  attendre le suivant
		}
		referme_imbrique();
	}
	else if (!fonction.compare("fi")){
		if (imbriqueactu->type != imbrique::IF ){
			/* on a <fi> et on n'tait pas dans <if> */
			erreur("<fi> inattendu");
		}
		referme_imbrique();
	}
	/* <FOR variable IN liste telle qu'avec echo> blabla <DONE> */
	else if (!fonction.compare("for")){
		ouvre_imbrique();
		imbriqueactu->type=imbrique::FOR;
		cefor=&(imbriqueactu->info.pourfor);
		cefor->fichier=quelfichier();
		cefor->pos=queloffset();
		cefor->ligne=quelleligne();
		cefor->numval=0;
		ligne="liste_shell "+chaine;
		envoieshell(ligne);
		if (!recoitshell(ligne,1)){ // ici on supprime les fins de ligne: chaque ligne est un argument
			erreur("Pas d'argument dans <for>: <FOR %s>",chaine.c_str());
		}
		cefor->var=ligne;
		i=1;
		if (recoitshell(ligne,1)) if (!strcasecmp(ligne.c_str(),"in")) i=0;
		if (i){
			erreur("Syntaxe: <FOR variable IN liste>: <FOR %s>",chaine.c_str());
		}
		i=0;/*nombre de valeurs rentres*/
		vector<string> *liste = &imbriqueactu->info.pourfor.liste;
		while(recoitshell(ligne,1)){
			liste->push_back(ligne);
		}
		if(liste->size()){
			ligne="read -r " + cefor->var + " <<" + string(fin_read) + "\n" + (*liste)[0] + "\n" + string(fin_read);
			execshell(ligne);
		}
		else{ /*for variable in <liste vide>: d'accord, on ne fait rien*/
			referme_imbrique();
			attend("done");
		}
	}
	/* <WHILE condition_vraie> .... <DONE> */
	else if (!fonction.compare("while")){
		ouvre_imbrique();
		imbriqueactu->type=imbrique::WHILE;
		cewhile=&(imbriqueactu->info.pourwhile);
		cewhile->fichier=quelfichier();
		cewhile->pos=queloffset();
		cewhile->ligne=quelleligne();
		cewhile->condition=chaine.c_str();
		if (!vraifaux("while",chaine.c_str())){ /* si c'est faux, je saute  <DONE> */
			attend("done");
			referme_imbrique();
		}
	}

	/* <DONE>, qui termine <FOR> ou bien <WHILE> */
	else if (!fonction.compare("done")){
		if (imbriqueactu->type==imbrique::FOR){
			cefor=&(imbriqueactu->info.pourfor);
			cefor->numval++;
			if (cefor->numval == cefor->liste.size()){ /* on a fini la liste*/
				referme_imbrique();
			}else{ /* on passe  la valeur suivante, et on reboucle*/
				ligne="read -r " + cefor->var + " <<" + string(fin_read) + "\n" + cefor->liste[cefor->numval] + "\n" + string(fin_read);
				execshell(ligne);
				revient(cefor->fichier,cefor->pos,cefor->ligne);
			}
		}
		else if (imbriqueactu->type==imbrique::WHILE){
			cewhile=&(imbriqueactu->info.pourwhile);
			if (vraifaux("while",cewhile->condition.c_str())){/* vrai, je retourne au while */
				revient(cewhile->fichier,cewhile->pos,cewhile->ligne);
			}else{ /* faux, je sors de l'imbrication */
				referme_imbrique();
			}
		}
	}
	/* <INCLUDE liste de fichiers> (format de cat) */
	/* et <REINCLUDE liste de fichiers> (idem mais recommence le fichier de
	                                     *         sortie  zro et inclut l'entte du fichier inclus */
	/* et <NOTINCLUDE liste de fichiers> (idem mais n'affiche pas le contenu) */
	/* <REINCLUDE> ne marche pas si on est dj dans <NOTINCLUDE> */
	else if ((!fonction.compare("reinclude")) && (!affiche)) {}
	else if ((!fonction.compare("include")) || 
	         (!fonction.compare("notinclude")) ||
	         (!fonction.compare("reinclude")) ){
				 ouvre_imbrique();
				 imbriqueactu->type=imbrique::INCLUDE;
				 ceinc=&(imbriqueactu->info.pourinclude);
				 ceinc->numfich = 0; // correction bug 11/09/2011
				 ceinc->affiche=affiche;
				 /* si on n'affichait pas, on n'affiche toujours pas, mais si on
				  * affichait et qu'on trouve <notinclude>, on n'affiche plus */
				 if (!fonction.compare("notinclude")) 
					 affiche=0;
				 /* J'interdisais <reinclude> dans les fichiers inclus, mais je ne le fais plus:
				  * maintenant c'est autoris sauf si on n'est pas en train d'afficher: reinclude
				  * ne marche pas dans <notinclude>, mais marche dans <include> et <reinclude> */
				 if ((!fonction.compare("reinclude"))/* && (!fichier_courant->pere)*/)
					 flag_reinclude=1;
				 else
					 flag_reinclude=0;
				 ligne="liste_shell "+chaine;
				 envoieshell(ligne);
				 i=0;/*nombre de valeurs rentres*/
				 vector<string> *liste = &ceinc->liste;
				 while(recoitshell(ligne,1)){  // suppression des fins de ligne pour "liste_shell"
					 liste->push_back(ligne);
				 }
				 if(liste->size()) /* INCLUDE <fichier>... : on inclut le premier */
					 inclure_fichier((*liste)[0].c_str());
				 else /* INCLUDE <liste vide>: d'accord, on ne fait rien*/
					 referme_imbrique();
			 }
	/* cas spciaux du couple <GENERATE un fichier>....</GENERATE>
	 * au lieu de crer le fichier du dpart, cre une srie de fichiers,
	 * avec ces instructions mises dans une boucle */
	/* <GENERATE fichier> */
	else if (!fonction.compare("generate")){
		ligne="echo "+chaine;
		envoieshell(ligne);
		recoitshell(ligne,1);
		genere(ligne.c_str());
		if (recoitshell(ligne,1)) erreur("Trop de lignes dans la sortie de "
		                                 "<GENERATE %s>",chaine.c_str());
	}
	/* </GENERATE> */
	else if (!fonction.compare("/generate")){
		degenere();
	}
	/* <REM> */
	else if (!fonction.compare("rem")){
		// le but de la balise <REM ....> est de ne rien faire du tout
	}

	/* <FONCTION LISTE MAIS PAS ENCORE GRE > */    
	/* normalement, il n'y en a pas */

	/* <BODY> et </BODY>, pour n'inclure que le corps des fichiers */
	else if (!fonction.compare("body")){
		/* rien  faire, si on est dans le main, sinon c'est anormal*/
		if (fichier_courant->profondeur)
			warning("balise <BODY> trouve dans un fichier inclus: 2e exemplaire?");
	}
	else if (!fonction.compare("/body")){
		/* si on est dans un fichier inclus, on sort du fichier */
		if (fichier_courant->profondeur)
			fseek(fichier_courant->fd,0,SEEK_END); /* le prochain car. sera EOF */
	}

	else erreur("Erreur interne: fonction <%s> (argument='%s') "
	            "liste mais pas gre\n",fonction.c_str(),chaine.c_str());
}
