#include "prehtml.h"

const char *typeimbrique(imbrique *i){
  switch(i->type){
   case imbrique::MAIN:return "top-level";
   case imbrique::IF:return "IF";
   case imbrique::FOR:return "FOR";
   case imbrique::WHILE:return "WHILE";
   case imbrique::INCLUDE:return "(NOT)INCLUDE";
   default:return "inconnue";
  }
}

int attend(const char *etiq){ /* trouve le champ "etiq" correspondant sans
			  * excuter le code intermdiaire, mais en
			  * faisant attention aux imbrications*/
  /* si etiq="else", renvoie 1 si trouv, et 0 si a rencontr "fi", et 2 si a rencontr "elif" */
  const char *autorisee[]={"else","fi","done",NULL};
  int i;
  for (i=0;autorisee[i];i++) if (!strcmp(autorisee[i],etiq)) break;
  if (!autorisee[i]) {
    erreur("attend() ne peut pas attendre l'tiquette <%s>",etiq);
  }
  while(1){
    i=decode();
    if (i==EOF) erreur("EOF rencontr alors que j'attendais <%s>",etiq);
    if (i!=EST_FONCTION) continue;
    /* fonctions qui terminent des imbrications */
    if (!fonction.compare("else")){
      if (!strcmp(etiq,"else")) return 1; /* mission accomplie */
      erreur("<else> rencontr alors que j'attendais <%s>",etiq);
    }
    if (!fonction.compare("fi")){
      if (!strcmp(etiq,"fi")) return 1; /* mission accomplie */
      if (!strcmp(etiq,"else")) return 0; /* ce <if> n'a donc pas de <else>*/
      erreur("<fi> rencontr alors que j'attendais <%s>",etiq);
    }
    if (!fonction.compare("elif")){
      if (!strcmp(etiq,"else")) return 2; /* ce <if> continue par un <elif>*/
      if (!strcmp(etiq,"fi")) continue; /* j'attendais <fi> et j'ai <elif> => je continue  attendre <fi> */
      erreur("<elif> rencontr alors que j'attendais <%s>",etiq);
    }
    if (!fonction.compare("done")){
      if (!strcmp(etiq,"done")) return 1; /* mission accomplie */
      erreur("<done> rencontr alors que j'attendais <%s>",etiq);
    }
    /* fonctions qui commencent des imbrications */
    if (!fonction.compare("if")) {
	  int ret;
	  while(1){
		ret=attend("else");
		if (ret==2) continue; // trouv "elif", continuer
		if (ret==1) attend("fi"); // trouv "else", maintenant chercher "fi"
		break; // aprs avoir trouv "fi" (immdiatement, ret=0, ou aprs "else"), on sort
	  }
      continue;
    }
    if ( (!fonction.compare("while")) || (!fonction.compare("for")) ) {
      attend("done");
      continue;
    }
  }
}

vector<imbrique> imbrications;
imbrique *imbriqueactu=NULL;

void referme_imbrique(void){ /* referme l'imbrication courant */
  switch(imbriqueactu->type){
   case imbrique::MAIN:
    erreur("erreur interne: referme_imbrique() au top-niveau");
   case imbrique::IF:
   case imbrique::FOR:
   case imbrique::WHILE:
   case imbrique::INCLUDE:
    break;
   default: erreur("erreur interne: referme_imbrique: type non gr");
  }
  imbrications.pop_back();
  imbriqueactu = &imbrications.back();
}

void ouvre_imbrique(void){ /* operations gnriques pour tous les types */
  imbrique i;
  imbrications.push_back(i);
  imbriqueactu = &imbrications.back();
}
